'infoPod Version 0.1
'(c)2004 Simon Strudwick (Struddie) s.strudwick@magic-pie.co.uk
'http://eightyone.fizweb.net
'------------------------------------------------------------------------------
'You may uses this code as you wish, provided this header stays as is.
'You may add additional lines below for any the code you have written.
'------------------------------------------------------------------------------
'Version 0.1
' *Initial release, feedback appreciated
'------------------------------------------------------------------------------
'Put in the scripts folder and create a new Active Script Meter and point at
'infoPod.vbs.
'GetInfo returns a string to display
'GetiPodDrive returns the drive letter for the iPod
'GetSongCount returns the number of songs on the iPod

'------------------------------------------------------------------------------
'Settings
Const InfoString = "Your iPod is connected as %d:, %c songs using %uGB of %sGB, %fGB free"
' This is the string that is returned from the GetInfo function
'	%d is the iPod drive letter
'	%c is the number of songs on the iPod
'	%s is the total space available
'	%u is the used space
'	%f is the free space
Const OverrideiPodDrive = ""
' Use this if the script is returning the incorrect drive for the iPod or
' giving an error. Just enter the letter, NOT the ":\". To let the script find
' the drive, leave as "" (empty speach marks)
'------------------------------------------------------------------------------

Function GetInfo()
	On Error Resume Next
	Dim PodDrive 'The Drive letter of the iPod
	if OverrideiPodDrive = "" then
		PodDrive = GetiPodDrive & ":\"
	else
		PodDrive = OverrideiPodDrive & ":\"
	End if

	If err.number >0 then 'if there was an error then let us know what it was
		'GetInfo = Err.Number & " - " & Err.Description
		GetInfo = "iPod Disconnected"
		Exit Function
	Else 'build string and return
		Dim strOut
		strOut = replace(InfoString, "%d", GetiPodDrive)
		strOut = replace(strOut, "%c", GetSongCount)
		strOut = replace(strOut, "%u", GetUsedSpace)
		strOut = replace(strOut, "%s", GetSize)
		strOut = replace(strOut, "%f", GetFreeSpace)
		GetInfo = strOut	
		'GetInfo = "iPod connected as " & GetiPodDrive & ":, XXX songs using " & intUsed & "GB of " & intTotal & "GB"
	End If		
End Function

Function GetSongCount()
	On Error Resume Next
	Dim PodDrive 'The Drive letter of the iPod
	if OverrideiPodDrive = "" then
		PodDrive = GetiPodDrive & ":\"
	else
		PodDrive = OverrideiPodDrive & ":\"
	end if
	
	If PodDrive = "iPod Disconnected" then 'if there is no iPod connected then dislay a friendly message
		GetSongCount = "iPod Disconnected"
		Exit Function
	End If
	
	Dim intFiles 'The number of music files that we will add up and reutrn
	
	Dim objFso, objDir, i
	Set objFso = CreateObject("Scripting.FileSystemObject") 'create FSObject
	
	For i = 0 to 49 'count files in iPod_Control\Music\F00 to F49
		Set objDir = objFso.GetFolder(PodDrive & "iPod_Control\Music\F" & PadDigits(i, 2, "0"))
		'Set fc = objDir.Files
	
		If err.number >0 then 'if there was an error then let us know what it was
			'GetInfo = Err.Number & " - " & Err.Description
			GetSongCount = "iPod Disconnected"
			Exit Function
		Else 'add the file count to intFiles
			intFiles = intFiles + objDir.Files.Count
		End If	
	Next 'i
	
	GetSongCount = intFiles 'Return the result
End Function

Function GetiPodDrive()
	'Get the ipod drive letter
	On Error Resume Next
	if OverrideiPodDrive = "" then
		Dim objFso, objDrives, objDrv
		Set objFso = CreateObject("Scripting.FileSystemObject") 'create FSObject

		Set objDrives = objFso.Drives
		For each objDrv in objDrives
			if objDrv.DriveLetter <> "A" or objDrv.DriveLetter <> "B" then
				if objDrv.isReady then
					if objFso.FolderExists(objDrv.DriveLetter & ":\iPod_Control\Music") then
						GetiPodDrive = objDrv.DriveLetter
						Exit Function
					else
						GetiPodDrive = "iPod Disconnected"
					End if
				end if
			end if
		next 'objDrv
	else
		GetiPodDrive = OverrideiPodDrive
	end if
End Function

Function GetSize()
	On Error Resume Next
	Dim PodDrive 'Get Drive letter
	if OverrideiPodDrive = "" then
		PodDrive = GetiPodDrive & ":\"
	else
		PodDrive = OverrideiPodDrive & ":\"
	End if
	Dim objFso, objDrv
	Set objFso = CreateObject("Scripting.FileSystemObject") 'create FSObject
	set objDrv = objFso.GetDrive(objFso.GetDriveName(PodDrive))
	
	Dim intTotal
	intTotal = objDrv.TotalSize
	GetSize = round(intTotal / 1024 / 1024 / 1024, 2)
End Function

Function GetUsedSpace()
	On Error Resume Next
	Dim PodDrive 'Get Drive letter
	if OverrideiPodDrive = "" then
		PodDrive = GetiPodDrive & ":\"
	else
		PodDrive = OverrideiPodDrive & ":\"
	End if
	Dim objFso, objDrv
	Set objFso = CreateObject("Scripting.FileSystemObject") 'create FSObject
	set objDrv = objFso.GetDrive(objFso.GetDriveName(PodDrive))
	
	Dim intTotal, intFree
	intTotal = objDrv.TotalSize
	intTotal = round(intTotal / 1024 / 1024 / 1024, 2)
	intFree = objDrv.FreeSpace
	intFree = round(intFree / 1024 / 1024 / 1024, 2)
	GetUsedSpace = intTotal - intFree
End Function

Function GetFreeSpace()
	On Error Resume Next
	Dim PodDrive 'Get Drive letter
	if OverrideiPodDrive = "" then
		PodDrive = GetiPodDrive & ":\"
	else
		PodDrive = OverrideiPodDrive & ":\"
	End if
	Dim objFso, objDrv
	Set objFso = CreateObject("Scripting.FileSystemObject") 'create FSObject
	set objDrv = objFso.GetDrive(objFso.GetDriveName(PodDrive))

	Dim intFree
	intFree = objDrv.FreeSpace
	GetFreeSpace = round(intFree / 1024 / 1024 / 1024, 2)
End Function

Function GetPercentUsed()
	On Error Resume Next
	Dim PodDrive 'Get Drive letter
	if OverrideiPodDrive = "" then
		PodDrive = GetiPodDrive & ":\"
	else
		PodDrive = OverrideiPodDrive & ":\"
	End if
	Dim objFso, objDrv
	Set objFso = CreateObject("Scripting.FileSystemObject") 'create FSObject
	set objDrv = objFso.GetDrive(objFso.GetDriveName(PodDrive))
	
	Dim intTotal, intFree, intUsed
	intTotal = objDrv.TotalSize
	intTotal = round(intTotal / 1024 / 1024 / 1024, 0)
	intFree = objDrv.FreeSpace
	intFree = round(intFree / 1024 / 1024 / 1024, 0)
	intUsed = intTotal - intFree
	GetPercentUsed = round((intUsed / intTotal) * 100, 2)
End Function

Function GetPercentFree()
	On Error Resume Next
	Dim PodDrive 'Get Drive letter
	if OverrideiPodDrive = "" then
		PodDrive = GetiPodDrive & ":\"
	else
		PodDrive = OverrideiPodDrive & ":\"
	End if
	Dim objFso, objDrv
	Set objFso = CreateObject("Scripting.FileSystemObject") 'create FSObject
	set objDrv = objFso.GetDrive(objFso.GetDriveName(PodDrive))
	
	Dim intTotal, intFree
	intTotal = objDrv.TotalSize
	intTotal = round(intTotal / 1024 / 1024 / 1024, 0)
	intFree = objDrv.FreeSpace
	intFree = round(intFree / 1024 / 1024 / 1024, 0)
	GetPercentFree = round((intFree / intTotal) * 100, 2)
End Function

  Private Function PadDigits(Number, totalDigits, PadWith)
  'Function to pad digits to a number
  'From ASPFAQ - http://www.aspfaq.com/show.asp?id=2300
  'Customized by Struddie
    if totalDigits > len(Number) then 
      PadDigits = String(totalDigits-len(Number),PadWith) & Number
    else 
      PadDigits = Number
    end if 
  End Function 